## wasi-libc 0.0~git20220510.9886d3d

=== Makefile ===
# These variables are specifically meant to be overridable via the make
# command-line.
# ?= doesn't work for CC and AR because make has a default value for them.
ifeq ($(origin CC), default)
CC := clang
endif
NM ?= $(patsubst %clang,%llvm-nm,$(filter-out ccache sccache,$(CC)))
ifeq ($(origin AR), default)
AR = $(patsubst %clang,%llvm-ar,$(filter-out ccache sccache,$(CC)))
endif
EXTRA_CFLAGS ?= -O2 -DNDEBUG
# The directory where we build the sysroot.
SYSROOT ?= $(CURDIR)/sysroot
# A directory to install to for "make install".
INSTALL_DIR ?= /usr/local
# single or posix
THREAD_MODEL ?= single
# dlmalloc or none
MALLOC_IMPL ?= dlmalloc
# yes or no
BUILD_LIBC_TOP_HALF ?= yes
# The directory where we're store intermediate artifacts.
OBJDIR ?= $(CURDIR)/build

# Variables from this point on are not meant to be overridable via the
# make command-line.

# Set the target variables. Multiarch triples notably omit the vendor field,
# which happens to be what we do for the main target triple too.
TARGET_TRIPLE = wasm32-wasi
MULTIARCH_TRIPLE = wasm32-wasi

# These variables describe the locations of various files and directories in
# the source tree.
DLMALLOC_DIR = $(CURDIR)/dlmalloc
DLMALLOC_SRC_DIR = $(DLMALLOC_DIR)/src
DLMALLOC_SOURCES = $(DLMALLOC_SRC_DIR)/dlmalloc.c
DLMALLOC_INC = $(DLMALLOC_DIR)/include
LIBC_BOTTOM_HALF_DIR = $(CURDIR)/libc-bottom-half
LIBC_BOTTOM_HALF_CLOUDLIBC_SRC = $(LIBC_BOTTOM_HALF_DIR)/cloudlibc/src
LIBC_BOTTOM_HALF_CLOUDLIBC_SRC_INC = $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/include
LIBC_BOTTOM_HALF_HEADERS_PUBLIC = $(LIBC_BOTTOM_HALF_DIR)/headers/public
LIBC_BOTTOM_HALF_HEADERS_PRIVATE = $(LIBC_BOTTOM_HALF_DIR)/headers/private
LIBC_BOTTOM_HALF_SOURCES = $(LIBC_BOTTOM_HALF_DIR)/sources
LIBC_BOTTOM_HALF_ALL_SOURCES = \
    $(shell find $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC) -name \*.c) \
    $(shell find $(LIBC_BOTTOM_HALF_SOURCES) -name \*.c)

# FIXME(https://reviews.llvm.org/D85567) - due to a bug in LLD the weak
# references to a function defined in `chdir.c` only work if `chdir.c` is at the
# end of the archive, but once that LLD review lands and propagates into LLVM
# then we don't have to do this.
LIBC_BOTTOM_HALF_ALL_SOURCES := $(filter-out $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c,$(LIBC_BOTTOM_HALF_ALL_SOURCES))
LIBC_BOTTOM_HALF_ALL_SOURCES := $(LIBC_BOTTOM_HALF_ALL_SOURCES) $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c

LIBWASI_EMULATED_MMAN_SOURCES = \
    $(shell find $(LIBC_BOTTOM_HALF_DIR)/mman -name \*.c)
LIBWASI_EMULATED_PROCESS_CLOCKS_SOURCES = \
    $(shell find $(LIBC_BOTTOM_HALF_DIR)/clocks -name \*.c)
LIBWASI_EMULATED_GETPID_SOURCES = \
    $(shell find $(LIBC_BOTTOM_HALF_DIR)/getpid -name \*.c)
LIBWASI_EMULATED_SIGNAL_SOURCES = \
    $(shell find $(LIBC_BOTTOM_HALF_DIR)/signal -name \*.c)
LIBWASI_EMULATED_SIGNAL_MUSL_SOURCES = \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/signal/psignal.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/strsignal.c
LIBC_BOTTOM_HALF_CRT_SOURCES = $(wildcard $(LIBC_BOTTOM_HALF_DIR)/crt/*.c)
LIBC_TOP_HALF_DIR = $(CURDIR)/libc-top-half
LIBC_TOP_HALF_MUSL_DIR = $(LIBC_TOP_HALF_DIR)/musl
LIBC_TOP_HALF_MUSL_SRC_DIR = $(LIBC_TOP_HALF_MUSL_DIR)/src
LIBC_TOP_HALF_MUSL_INC = $(LIBC_TOP_HALF_MUSL_DIR)/include
LIBC_TOP_HALF_MUSL_SOURCES = \
    $(addprefix $(LIBC_TOP_HALF_MUSL_SRC_DIR)/, \
        misc/a64l.c \
        misc/basename.c \
        misc/dirname.c \
        misc/ffs.c \
        misc/ffsl.c \
        misc/ffsll.c \
        misc/fmtmsg.c \
        misc/getdomainname.c \
        misc/gethostid.c \
        misc/getopt.c \
        misc/getopt_long.c \
        misc/getsubopt.c \
        misc/uname.c \
        misc/nftw.c \
        errno/strerror.c \
        network/htonl.c \
        network/htons.c \
        network/ntohl.c \
        network/ntohs.c \
        network/inet_ntop.c \
        network/inet_pton.c \
        network/inet_aton.c \
        network/in6addr_any.c \
        network/in6addr_loopback.c \
        fenv/fenv.c \
        fenv/fesetround.c \
        fenv/feupdateenv.c \
        fenv/fesetexceptflag.c \
        fenv/fegetexceptflag.c \
        fenv/feholdexcept.c \
        exit/exit.c \
        exit/atexit.c \
        exit/assert.c \
        exit/quick_exit.c \
        exit/at_quick_exit.c \
        time/strftime.c \
        time/asctime.c \
        time/asctime_r.c \
        time/ctime.c \
        time/ctime_r.c \
        time/wcsftime.c \
        time/strptime.c \
        time/difftime.c \
        time/timegm.c \
        time/ftime.c \
        time/gmtime.c \
        time/gmtime_r.c \
        time/timespec_get.c \
        time/getdate.c \
        time/localtime.c \
        time/localtime_r.c \
        time/mktime.c \
        time/__tm_to_secs.c \
        time/__month_to_secs.c \
        time/__secs_to_tm.c \
        time/__year_to_secs.c \
        time/__tz.c \
        fcntl/creat.c \
        dirent/alphasort.c \
        dirent/versionsort.c \
        env/clearenv.c \
        env/getenv.c \
        env/putenv.c \
        env/setenv.c \
        env/unsetenv.c \
        unistd/posix_close.c \
        stat/futimesat.c \
    ) \
    $(filter-out %/procfdname.c %/syscall.c %/syscall_ret.c %/vdso.c %/version.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/*.c)) \
    $(filter-out %/flockfile.c %/funlockfile.c %/__lockfile.c %/ftrylockfile.c \
                 %/rename.c \
                 %/tmpnam.c %/tmpfile.c %/tempnam.c \
                 %/popen.c %/pclose.c \
                 %/remove.c \
                 %/gets.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/*.c)) \
    $(filter-out %/strsignal.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/*.c)) \
    $(filter-out %/dcngettext.c %/textdomain.c %/bind_textdomain_codeset.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/locale/*.c)) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/search/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/multibyte/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/regex/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/prng/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/conf/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/ctype/*.c) \
    $(filter-out %/__signbit.c %/__signbitf.c %/__signbitl.c \
                 %/__fpclassify.c %/__fpclassifyf.c %/__fpclassifyl.c \
                 %/ceilf.c %/ceil.c \
                 %/floorf.c %/floor.c \
                 %/truncf.c %/trunc.c \
                 %/rintf.c %/rint.c \
                 %/nearbyintf.c %/nearbyint.c \
                 %/sqrtf.c %/sqrt.c \
                 %/fabsf.c %/fabs.c \
                 %/copysignf.c %/copysign.c \
                 %/fminf.c %/fmaxf.c \
                 %/fmin.c %/fmax.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/math/*.c)) \
    $(filter-out %/crealf.c %/creal.c %creall.c \
                 %/cimagf.c %/cimag.c %cimagl.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/complex/*.c)) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/crypt/*.c)
MUSL_PRINTSCAN_SOURCES = \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/floatscan.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfprintf.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfwprintf.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfscanf.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/strtod.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/wcstod.c
LIBC_TOP_HALF_HEADERS_PRIVATE = $(LIBC_TOP_HALF_DIR)/headers/private
LIBC_TOP_HALF_SOURCES = $(LIBC_TOP_HALF_DIR)/sources
LIBC_TOP_HALF_ALL_SOURCES = \
    $(LIBC_TOP_HALF_MUSL_SOURCES) \
    $(shell find $(LIBC_TOP_HALF_SOURCES) -name \*.c)

# Add any extra flags
CFLAGS = $(EXTRA_CFLAGS)
# Set the target.
CFLAGS += --target=$(TARGET_TRIPLE)
# WebAssembly floating-point match doesn't trap.
# TODO: Add -fno-signaling-nans when the compiler supports it.
CFLAGS += -fno-trapping-math
# Add all warnings, but disable a few which occur in third-party code.
CFLAGS += -Wall -Wextra -Werror \
  -Wno-null-pointer-arithmetic \
  -Wno-unused-parameter \
  -Wno-sign-compare \
  -Wno-unused-variable \
  -Wno-unused-function \
  -Wno-ignored-attributes \
  -Wno-missing-braces \
  -Wno-ignored-pragmas \
  -Wno-unused-but-set-variable \
  -Wno-unknown-warning-option

# Configure support for threads.
ifeq ($(THREAD_MODEL), single)
CFLAGS += -mthread-model single
endif
ifeq ($(THREAD_MODEL), posix)
CFLAGS += -mthread-model posix -pthread
endif

# Expose the public headers to the implementation. We use `-isystem` for
# purpose for two reasons:
#
# 1. It only does `<...>` not `"...."` lookup. We are making a libc,
#    which is a system library, so all public headers should be
#    accessible via `<...>` and never also need `"..."`. `-isystem` main
#    purpose is to only effect `<...>` lookup.
#
# 2. The `-I` for private headers added for specific C files below
#    should come earlier in the search path, so they can "override"
#    and/or `#include_next` the public headers. `-isystem` (like
#    `-idirafter`) comes later in the search path than `-I`.
CFLAGS += -isystem "$(SYSROOT_INC)"

# These variables describe the locations of various files and directories in
# the build tree.
objs = $(patsubst $(CURDIR)/%.c,$(OBJDIR)/%.o,$(1))
DLMALLOC_OBJS = $(call objs,$(DLMALLOC_SOURCES))
LIBC_BOTTOM_HALF_ALL_OBJS = $(call objs,$(LIBC_BOTTOM_HALF_ALL_SOURCES))
LIBC_TOP_HALF_ALL_OBJS = $(call objs,$(LIBC_TOP_HALF_ALL_SOURCES))
ifeq ($(MALLOC_IMPL),dlmalloc)
LIBC_OBJS += $(DLMALLOC_OBJS)
else ifeq ($(MALLOC_IMPL),none)
# No object files to add.
else
$(error unknown malloc implementation $(MALLOC_IMPL))
endif
# Add libc-bottom-half's objects.
LIBC_OBJS += $(LIBC_BOTTOM_HALF_ALL_OBJS)
ifeq ($(BUILD_LIBC_TOP_HALF),yes)
# libc-top-half is musl.
LIBC_OBJS += $(LIBC_TOP_HALF_ALL_OBJS)
endif
MUSL_PRINTSCAN_OBJS = $(call objs,$(MUSL_PRINTSCAN_SOURCES))
MUSL_PRINTSCAN_LONG_DOUBLE_OBJS = $(patsubst %.o,%.long-double.o,$(MUSL_PRINTSCAN_OBJS))
MUSL_PRINTSCAN_NO_FLOATING_POINT_OBJS = $(patsubst %.o,%.no-floating-point.o,$(MUSL_PRINTSCAN_OBJS))
LIBWASI_EMULATED_MMAN_OBJS = $(call objs,$(LIBWASI_EMULATED_MMAN_SOURCES))
LIBWASI_EMULATED_PROCESS_CLOCKS_OBJS = $(call objs,$(LIBWASI_EMULATED_PROCESS_CLOCKS_SOURCES))
LIBWASI_EMULATED_GETPID_OBJS = $(call objs,$(LIBWASI_EMULATED_GETPID_SOURCES))
LIBWASI_EMULATED_SIGNAL_OBJS = $(call objs,$(LIBWASI_EMULATED_SIGNAL_SOURCES))
LIBWASI_EMULATED_SIGNAL_MUSL_OBJS = $(call objs,$(LIBWASI_EMULATED_SIGNAL_MUSL_SOURCES))

# These variables describe the locations of various files and
# directories in the generated sysroot tree.
SYSROOT_LIB := $(SYSROOT)/lib/$(MULTIARCH_TRIPLE)
SYSROOT_INC = $(SYSROOT)/include
SYSROOT_SHARE = $(SYSROOT)/share/$(MULTIARCH_TRIPLE)

# Files from musl's include directory that we don't want to install in the
# sysroot's include directory.
MUSL_OMIT_HEADERS :=

# Remove files which aren't headers (we generate alltypes.h below).
MUSL_OMIT_HEADERS += \
    "bits/syscall.h.in" \
    "bits/alltypes.h.in" \
    "alltypes.h.in"

# Use the compiler's version of these headers.
MUSL_OMIT_HEADERS += \
    "stdarg.h" \
    "stddef.h"

# Use the WASI errno definitions.
MUSL_OMIT_HEADERS += \
    "bits/errno.h"

# Remove headers that aren't supported yet or that aren't relevant for WASI.
MUSL_OMIT_HEADERS += \
    "sys/procfs.h" \
    "sys/user.h" \
    "sys/kd.h" "sys/vt.h" "sys/soundcard.h" "sys/sem.h" \
    "sys/shm.h" "sys/msg.h" "sys/ipc.h" "sys/ptrace.h" \
    "sys/statfs.h" \
    "bits/kd.h" "bits/vt.h" "bits/soundcard.h" "bits/sem.h" \
    "bits/shm.h" "bits/msg.h" "bits/ipc.h" "bits/ptrace.h" \
    "bits/statfs.h" \
    "sys/vfs.h" \
    "sys/statvfs.h" \
    "syslog.h" "sys/syslog.h" \
    "wait.h" "sys/wait.h" \
    "ucontext.h" "sys/ucontext.h" \
    "paths.h" \
    "utmp.h" "utmpx.h" \
    "lastlog.h" \
    "sys/acct.h" \
    "sys/cachectl.h" \
    "sys/epoll.h" "sys/reboot.h" "sys/swap.h" \
    "sys/sendfile.h" "sys/inotify.h" \
    "sys/quota.h" \
    "sys/klog.h" \
    "sys/fsuid.h" \

=== debian/changelog ===
wasi-libc (0.0~git20220510.9886d3d-2) unstable; urgency=medium

  * d/copyright: add missing license info
  * bump Standards-Version to 4.6.1
  * bump debhelper compat to 13

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Wed, 07 Dec 2022 19:57:26 +0100

wasi-libc (0.0~git20220510.9886d3d-1) unstable; urgency=medium

  * Upload to unstable.

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Wed, 07 Dec 2022 17:37:58 +0100

wasi-libc (0.0~git20220510.9886d3d-1~exp1) experimental; urgency=medium

  * New upstream release
  * Update to LLVM 14, same as rustc (Closes: #1017661)

 -- Fabian Grünbichler <f.gruenbichler@proxmox.com>  Thu, 29 Sep 2022 12:11:17 +0200

=== debian/control ===
Source: wasi-libc
Section: devel
Priority: optional
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders: Ximin Luo <infinity0@debian.org>
Build-Depends: debhelper-compat (= 13), clang-14, llvm-14
Standards-Version: 4.6.1
Homepage: https://github.com/CraneStation/wasi-libc
Vcs-Browser: https://salsa.debian.org/rust-team/wasi-libc
Vcs-Git: https://salsa.debian.org/rust-team/wasi-libc.git

Package: wasi-libc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: WASI libc implementation for WebAssembly
 This is a work in progress. It's usable for many purposes, though the APIs
 aren't stable yet. For example, this is used by the Rust compiler to build
 its standard library for the wasm32-wasi target.
 .
 First, it's a usable libc. It builds a "libc" which can be used by compilers,
 such as Clang 8.0, using the wasm32-wasi target. It's a work in progress, but
 it is already sufficient to run basic programs.
 .
 Second, it's a "reference" implementation, which means the interfaces defined
 here can be used by other tools and libraries, even if they don't use all the
 actual implementations here. For example, we don't expect everyone will want to
 use the exact malloc implementation provided here, but tools and libraries
 using an ABI-compatible malloc interface will be able to interoperate
 regardless of which actual implementation is used.
 .
 Third, it's an example showing the use of the WASI API. The libc functionality
 is implemented using calls to WASI functions.

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/buildflags.mk

export NM = llvm-nm-14
export AR = llvm-ar-14
export CC = clang-14

# stack protector not yet supported, see
# https://github.com/CraneStation/wasi-libc/issues/157
export EXTRA_CFLAGS = $(CFLAGS) $(LDFLAGS) -fno-stack-protector

%:
	dh $@

.PHONY: build
build:
	dh $@

override_dh_auto_build:
	dh_auto_build -- finish

override_dh_auto_install:
	dh_auto_install -- INSTALL_DIR=$(CURDIR)/debian/tmp/usr

## wasi-libc 0.0~git20230113.4362b18

=== Makefile ===
# These variables are specifically meant to be overridable via the make
# command-line.
# ?= doesn't work for CC and AR because make has a default value for them.
ifeq ($(origin CC), default)
CC := clang
endif
NM ?= $(patsubst %clang,%llvm-nm,$(filter-out ccache sccache,$(CC)))
ifeq ($(origin AR), default)
AR = $(patsubst %clang,%llvm-ar,$(filter-out ccache sccache,$(CC)))
endif
EXTRA_CFLAGS ?= -O2 -DNDEBUG
# The directory where we build the sysroot.
SYSROOT ?= $(CURDIR)/sysroot
# A directory to install to for "make install".
INSTALL_DIR ?= /usr/local
# single or posix; note that pthread support is still a work-in-progress.
THREAD_MODEL ?= single
# dlmalloc or none
MALLOC_IMPL ?= dlmalloc
# yes or no
BUILD_LIBC_TOP_HALF ?= yes
# The directory where we will store intermediate artifacts.
OBJDIR ?= $(CURDIR)/build/$(TARGET_TRIPLE)

# When the length is no larger than this threshold, we consider the
# overhead of bulk memory opcodes to outweigh the performance benefit,
# and fall back to the original musl implementation. See
# https://github.com/WebAssembly/wasi-libc/pull/263 for relevant
# discussion
BULK_MEMORY_THRESHOLD ?= 32

# Variables from this point on are not meant to be overridable via the
# make command-line.

# Set the default WASI target triple.
TARGET_TRIPLE = wasm32-wasi

# Threaded version necessitates a different traget, as objects from different
# targets can't be mixed together while linking.
ifeq ($(THREAD_MODEL), posix)
TARGET_TRIPLE = wasm32-wasi-threads
endif

# These variables describe the locations of various files and directories in
# the source tree.
DLMALLOC_DIR = $(CURDIR)/dlmalloc
DLMALLOC_SRC_DIR = $(DLMALLOC_DIR)/src
DLMALLOC_SOURCES = $(DLMALLOC_SRC_DIR)/dlmalloc.c
DLMALLOC_INC = $(DLMALLOC_DIR)/include
EMMALLOC_DIR = $(CURDIR)/emmalloc
EMMALLOC_SOURCES = $(EMMALLOC_DIR)/emmalloc.c
LIBC_BOTTOM_HALF_DIR = $(CURDIR)/libc-bottom-half
LIBC_BOTTOM_HALF_CLOUDLIBC_SRC = $(LIBC_BOTTOM_HALF_DIR)/cloudlibc/src
LIBC_BOTTOM_HALF_CLOUDLIBC_SRC_INC = $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/include
LIBC_BOTTOM_HALF_HEADERS_PUBLIC = $(LIBC_BOTTOM_HALF_DIR)/headers/public
LIBC_BOTTOM_HALF_HEADERS_PRIVATE = $(LIBC_BOTTOM_HALF_DIR)/headers/private
LIBC_BOTTOM_HALF_SOURCES = $(LIBC_BOTTOM_HALF_DIR)/sources
LIBC_BOTTOM_HALF_ALL_SOURCES = \
    $(sort \
    $(shell find $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC) -name \*.c) \
    $(shell find $(LIBC_BOTTOM_HALF_SOURCES) -name \*.c))

# FIXME(https://reviews.llvm.org/D85567) - due to a bug in LLD the weak
# references to a function defined in `chdir.c` only work if `chdir.c` is at the
# end of the archive, but once that LLD review lands and propagates into LLVM
# then we don't have to do this.
LIBC_BOTTOM_HALF_ALL_SOURCES := $(filter-out $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c,$(LIBC_BOTTOM_HALF_ALL_SOURCES))
LIBC_BOTTOM_HALF_ALL_SOURCES := $(LIBC_BOTTOM_HALF_ALL_SOURCES) $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c

LIBWASI_EMULATED_MMAN_SOURCES = \
    $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/mman -name \*.c))
LIBWASI_EMULATED_PROCESS_CLOCKS_SOURCES = \
    $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/clocks -name \*.c))
LIBWASI_EMULATED_GETPID_SOURCES = \
    $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/getpid -name \*.c))
LIBWASI_EMULATED_SIGNAL_SOURCES = \
    $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/signal -name \*.c))
LIBWASI_EMULATED_SIGNAL_MUSL_SOURCES = \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/signal/psignal.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/strsignal.c
LIBC_BOTTOM_HALF_CRT_SOURCES = $(wildcard $(LIBC_BOTTOM_HALF_DIR)/crt/*.c)
LIBC_TOP_HALF_DIR = $(CURDIR)/libc-top-half
LIBC_TOP_HALF_MUSL_DIR = $(LIBC_TOP_HALF_DIR)/musl
LIBC_TOP_HALF_MUSL_SRC_DIR = $(LIBC_TOP_HALF_MUSL_DIR)/src
LIBC_TOP_HALF_MUSL_INC = $(LIBC_TOP_HALF_MUSL_DIR)/include
LIBC_TOP_HALF_MUSL_SOURCES = \
    $(addprefix $(LIBC_TOP_HALF_MUSL_SRC_DIR)/, \
        misc/a64l.c \
        misc/basename.c \
        misc/dirname.c \
        misc/ffs.c \
        misc/ffsl.c \
        misc/ffsll.c \
        misc/fmtmsg.c \
        misc/getdomainname.c \
        misc/gethostid.c \
        misc/getopt.c \
        misc/getopt_long.c \
        misc/getsubopt.c \
        misc/uname.c \
        misc/nftw.c \
        errno/strerror.c \
        network/htonl.c \
        network/htons.c \
        network/ntohl.c \
        network/ntohs.c \
        network/inet_ntop.c \
        network/inet_pton.c \
        network/inet_aton.c \
        network/in6addr_any.c \
        network/in6addr_loopback.c \
        fenv/fenv.c \
        fenv/fesetround.c \
        fenv/feupdateenv.c \
        fenv/fesetexceptflag.c \
        fenv/fegetexceptflag.c \
        fenv/feholdexcept.c \
        exit/exit.c \
        exit/atexit.c \
        exit/assert.c \
        exit/quick_exit.c \
        exit/at_quick_exit.c \
        time/strftime.c \
        time/asctime.c \
        time/asctime_r.c \
        time/ctime.c \
        time/ctime_r.c \
        time/wcsftime.c \
        time/strptime.c \
        time/difftime.c \
        time/timegm.c \
        time/ftime.c \
        time/gmtime.c \
        time/gmtime_r.c \
        time/timespec_get.c \
        time/getdate.c \
        time/localtime.c \
        time/localtime_r.c \
        time/mktime.c \
        time/__tm_to_secs.c \
        time/__month_to_secs.c \
        time/__secs_to_tm.c \
        time/__year_to_secs.c \
        time/__tz.c \
        fcntl/creat.c \
        dirent/alphasort.c \
        dirent/versionsort.c \
        env/__stack_chk_fail.c \
        env/clearenv.c \
        env/getenv.c \
        env/putenv.c \
        env/setenv.c \
        env/unsetenv.c \
        unistd/posix_close.c \
        stat/futimesat.c \
        legacy/getpagesize.c \
        thread/thrd_sleep.c \
    ) \
    $(filter-out %/procfdname.c %/syscall.c %/syscall_ret.c %/vdso.c %/version.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/*.c)) \
    $(filter-out %/flockfile.c %/funlockfile.c %/__lockfile.c %/ftrylockfile.c \
                 %/rename.c \
                 %/tmpnam.c %/tmpfile.c %/tempnam.c \
                 %/popen.c %/pclose.c \
                 %/remove.c \
                 %/gets.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/*.c)) \
    $(filter-out %/strsignal.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/*.c)) \
    $(filter-out %/dcngettext.c %/textdomain.c %/bind_textdomain_codeset.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/locale/*.c)) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/search/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/multibyte/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/regex/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/prng/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/conf/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/ctype/*.c) \
    $(filter-out %/__signbit.c %/__signbitf.c %/__signbitl.c \
                 %/__fpclassify.c %/__fpclassifyf.c %/__fpclassifyl.c \
                 %/ceilf.c %/ceil.c \
                 %/floorf.c %/floor.c \
                 %/truncf.c %/trunc.c \
                 %/rintf.c %/rint.c \
                 %/nearbyintf.c %/nearbyint.c \
                 %/sqrtf.c %/sqrt.c \
                 %/fabsf.c %/fabs.c \
                 %/copysignf.c %/copysign.c \
                 %/fminf.c %/fmaxf.c \
                 %/fmin.c %/fmax.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/math/*.c)) \
    $(filter-out %/crealf.c %/creal.c %creall.c \
                 %/cimagf.c %/cimag.c %cimagl.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/complex/*.c)) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/crypt/*.c)

ifeq ($(THREAD_MODEL), posix)
LIBC_TOP_HALF_MUSL_SOURCES += \
    $(addprefix $(LIBC_TOP_HALF_MUSL_SRC_DIR)/, \
        env/__init_tls.c \
        stdio/__lockfile.c \
        stdio/flockfile.c \
        stdio/ftrylockfile.c \
        stdio/funlockfile.c \
        thread/__lock.c \
        thread/__wait.c \
        thread/__timedwait.c \
        thread/default_attr.c \
        thread/pthread_attr_destroy.c \
        thread/pthread_attr_get.c \
        thread/pthread_attr_init.c \
        thread/pthread_attr_setstack.c \
        thread/pthread_attr_setdetachstate.c \
        thread/pthread_attr_setstacksize.c \
        thread/pthread_barrier_destroy.c \
        thread/pthread_barrier_init.c \
        thread/pthread_barrier_wait.c \
        thread/pthread_cleanup_push.c \
        thread/pthread_cond_broadcast.c \
        thread/pthread_cond_destroy.c \
        thread/pthread_cond_init.c \
        thread/pthread_cond_signal.c \
        thread/pthread_cond_timedwait.c \
        thread/pthread_cond_wait.c \
        thread/pthread_condattr_destroy.c \
        thread/pthread_condattr_init.c \
        thread/pthread_condattr_setclock.c \
        thread/pthread_condattr_setpshared.c \
        thread/pthread_create.c \
        thread/pthread_detach.c \
        thread/pthread_equal.c \
        thread/pthread_getspecific.c \
        thread/pthread_join.c \
        thread/pthread_key_create.c \
        thread/pthread_mutex_consistent.c \
        thread/pthread_mutex_destroy.c \
        thread/pthread_mutex_init.c \
        thread/pthread_mutex_getprioceiling.c \
        thread/pthread_mutex_lock.c \
        thread/pthread_mutex_timedlock.c \
        thread/pthread_mutex_trylock.c \
        thread/pthread_mutex_unlock.c \
        thread/pthread_mutexattr_destroy.c \
        thread/pthread_mutexattr_init.c \
        thread/pthread_mutexattr_setprotocol.c \
        thread/pthread_mutexattr_setpshared.c \
        thread/pthread_mutexattr_setrobust.c \
        thread/pthread_mutexattr_settype.c \
        thread/pthread_once.c \
        thread/pthread_rwlock_destroy.c \
        thread/pthread_rwlock_init.c \
        thread/pthread_rwlock_rdlock.c \
        thread/pthread_rwlock_timedrdlock.c \
        thread/pthread_rwlock_timedwrlock.c \
        thread/pthread_rwlock_tryrdlock.c \
        thread/pthread_rwlock_trywrlock.c \
        thread/pthread_rwlock_unlock.c \
        thread/pthread_rwlock_wrlock.c \
        thread/pthread_rwlockattr_destroy.c \
        thread/pthread_rwlockattr_init.c \
        thread/pthread_rwlockattr_setpshared.c \
        thread/pthread_setcancelstate.c \
        thread/pthread_setspecific.c \
        thread/pthread_self.c \
        thread/pthread_testcancel.c \
        thread/sem_destroy.c \
        thread/sem_getvalue.c \
        thread/sem_init.c \
        thread/sem_post.c \
        thread/sem_timedwait.c \
        thread/sem_trywait.c \
        thread/sem_wait.c \
        thread/wasm32/wasi_thread_start.s \
    )
endif

MUSL_PRINTSCAN_SOURCES = \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/floatscan.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfprintf.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfwprintf.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfscanf.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/strtod.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/wcstod.c
BULK_MEMORY_SOURCES = \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/memcpy.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/memmove.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/memset.c
LIBC_TOP_HALF_HEADERS_PRIVATE = $(LIBC_TOP_HALF_DIR)/headers/private
LIBC_TOP_HALF_SOURCES = $(LIBC_TOP_HALF_DIR)/sources
LIBC_TOP_HALF_ALL_SOURCES = \
    $(LIBC_TOP_HALF_MUSL_SOURCES) \
    $(sort $(shell find $(LIBC_TOP_HALF_SOURCES) -name \*.[cs]))

# Add any extra flags
CFLAGS = $(EXTRA_CFLAGS)
# Set the target.
CFLAGS += --target=$(TARGET_TRIPLE)
ASMFLAGS += --target=$(TARGET_TRIPLE)
# WebAssembly floating-point match doesn't trap.
# TODO: Add -fno-signaling-nans when the compiler supports it.
CFLAGS += -fno-trapping-math
# Add all warnings, but disable a few which occur in third-party code.
CFLAGS += -Wall -Wextra -Werror \
  -Wno-null-pointer-arithmetic \
  -Wno-unused-parameter \
  -Wno-sign-compare \
  -Wno-unused-variable \

=== debian/changelog ===
wasi-libc (0.0~git20230113.4362b18-3) unstable; urgency=medium

  * switch to LLVM 16 (Closes: #1061217)

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Thu, 25 Jan 2024 21:48:31 +0100

wasi-libc (0.0~git20230113.4362b18-2) unstable; urgency=medium

  * Revert "build: enable stack protection" (Closes: #1051815)

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 13 Sep 2023 08:19:24 +0200

wasi-libc (0.0~git20230113.4362b18-1) unstable; urgency=medium

  * Upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Sun, 10 Sep 2023 19:22:19 +0200

wasi-libc (0.0~git20230113.4362b18-1~exp1) experimental; urgency=medium

  * new upstream version needed for rustc 1.68.2+
  * build: enable stack protection
  * d/control: update Standards-Version
  * update d/copyright
  * cleanup lintian overrides
  * add DEP-3 metadata to patches

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Fri, 08 Sep 2023 09:56:09 +0200

wasi-libc (0.0~git20221206.8b7148f-1) unstable; urgency=medium

  * Disable (not supported) cf-protection CFLAG
  * Add myself to Uploaders
  * Upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Sun, 03 Sep 2023 19:59:33 +0200

wasi-libc (0.0~git20221206.8b7148f-1~exp1) experimental; urgency=medium

  * Team upload.

  [ Blair Noctis ]
  * New upstream version
  * Refresh patches

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 26 Jul 2023 21:28:48 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: devel
 Priority: optional
 Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
-Uploaders: Ximin Luo <infinity0@debian.org>
-Build-Depends: debhelper-compat (= 13), clang-14, llvm-14
-Standards-Version: 4.6.1
+Uploaders:
+ Ximin Luo <infinity0@debian.org>,
+ Fabian Grünbichler <debian@fabian.gruenbichler.email>
+Build-Depends: debhelper-compat (= 13), clang-16, llvm-16
+Standards-Version: 4.6.2
 Homepage: https://github.com/CraneStation/wasi-libc
 Vcs-Browser: https://salsa.debian.org/rust-team/wasi-libc
 Vcs-Git: https://salsa.debian.org/rust-team/wasi-libc.git

=== debian/rules ===
--- 
+++ 
@@ -5,13 +5,14 @@
 
 include /usr/share/dpkg/buildflags.mk
 
-export NM = llvm-nm-14
-export AR = llvm-ar-14
-export CC = clang-14
+export NM = llvm-nm-16
+export AR = llvm-ar-16
+export CC = clang-16
 
 # stack protector not yet supported, see
 # https://github.com/CraneStation/wasi-libc/issues/157
-export EXTRA_CFLAGS = $(CFLAGS) $(LDFLAGS) -fno-stack-protector
+# https://bugs.debian.org/1051815
+export EXTRA_CFLAGS = $(CFLAGS) $(LDFLAGS) -fno-stack-protector -fcf-protection=none
 
 %:
 	dh $@

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://salsa.debian.org/rust-team/wasi-libc \
heads/upstream-orig

## wasi-libc 0.0~git20230821.ec4566b

=== debian/changelog ===
wasi-libc (0.0~git20230821.ec4566b-2) unstable; urgency=medium

  * upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Tue, 28 May 2024 17:07:51 +0200

wasi-libc (0.0~git20230821.ec4566b-1) experimental; urgency=medium

  * new upstream version needed for rustc 1.73+
  * switch to LLVM 17

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Tue, 28 May 2024 17:07:42 +0200

wasi-libc (0.0~git20230621.7018e24-2) unstable; urgency=medium

  * upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Mon, 27 May 2024 14:48:31 +0200

wasi-libc (0.0~git20230621.7018e24-1) experimental; urgency=medium

  * new upstream version needed for rustc 1.72.1+

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Fri, 24 May 2024 10:30:30 +0200

## wasi-libc 0.0~git20240411.9e8c542

=== debian/changelog ===
wasi-libc (0.0~git20240411.9e8c542-3) unstable; urgency=medium

  * enable "p2" variant, and symlink old one under the new "p1" name

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 31 Jul 2024 09:21:15 +0200

wasi-libc (0.0~git20240411.9e8c542-2) unstable; urgency=medium

  * upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 26 Jun 2024 08:47:27 +0200

wasi-libc (0.0~git20240411.9e8c542-1) experimental; urgency=medium

  * new upstream version needed for rustc 1.79+ (WASI SDK 22)

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 26 Jun 2024 08:47:04 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Ximin Luo <infinity0@debian.org>,
  Fabian Grünbichler <debian@fabian.gruenbichler.email>
-Build-Depends: debhelper-compat (= 13), clang-16, llvm-16
+Build-Depends: debhelper-compat (= 13), clang-17, llvm-17
 Standards-Version: 4.6.2
 Homepage: https://github.com/CraneStation/wasi-libc
 Vcs-Browser: https://salsa.debian.org/rust-team/wasi-libc

=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,9 @@
 
 include /usr/share/dpkg/buildflags.mk
 
-export NM = llvm-nm-16
-export AR = llvm-ar-16
-export CC = clang-16
+export NM = llvm-nm-17
+export AR = llvm-ar-17
+export CC = clang-17
 
 # stack protector not yet supported, see
 # https://github.com/CraneStation/wasi-libc/issues/157
@@ -23,6 +23,8 @@
 
 override_dh_auto_build:
 	dh_auto_build -- finish
+	dh_auto_build -- WASI_SNAPSHOT=p2 finish
 
 override_dh_auto_install:
 	dh_auto_install -- INSTALL_DIR=$(CURDIR)/debian/tmp/usr
+	dh_auto_install -- INSTALL_DIR=$(CURDIR)/debian/tmp/usr WASI_SNAPSHOT=p2

## wasi-libc 0.0~git20240708.3f43ea9

=== Makefile ===
--- 
+++ 
@@ -15,12 +15,23 @@
 INSTALL_DIR ?= /usr/local
 # single or posix; note that pthread support is still a work-in-progress.
 THREAD_MODEL ?= single
+# p1 or p2; the latter is not (yet) compatible with multithreading
+WASI_SNAPSHOT ?= p1
 # dlmalloc or none
 MALLOC_IMPL ?= dlmalloc
 # yes or no
 BUILD_LIBC_TOP_HALF ?= yes
+# yes or no
+BUILD_LIBSETJMP ?= yes
 # The directory where we will store intermediate artifacts.
-OBJDIR ?= $(CURDIR)/build/$(TARGET_TRIPLE)
+OBJDIR ?= build/$(TARGET_TRIPLE)
+# The directory where we store files and tools for generating WASIp2 bindings
+BINDING_WORK_DIR ?= build/bindings
+# URL from which to retrieve the WIT files used to generate the WASIp2 bindings
+WASI_CLI_URL ?= https://github.com/WebAssembly/wasi-cli/archive/refs/tags/v0.2.0.tar.gz
+# URL from which to retrieve the `wit-bindgen` command used to generate the
+# WASIp2 bindings.
+WIT_BINDGEN_URL ?= https://github.com/bytecodealliance/wit-bindgen/releases/download/wit-bindgen-cli-0.17.0/wit-bindgen-v0.17.0-x86_64-linux.tar.gz
 
 # When the length is no larger than this threshold, we consider the
 # overhead of bulk memory opcodes to outweigh the performance benefit,
@@ -35,21 +46,27 @@
 # Set the default WASI target triple.
 TARGET_TRIPLE = wasm32-wasi
 
-# Threaded version necessitates a different traget, as objects from different
+# Threaded version necessitates a different target, as objects from different
 # targets can't be mixed together while linking.
 ifeq ($(THREAD_MODEL), posix)
 TARGET_TRIPLE = wasm32-wasi-threads
 endif
 
+ifeq ($(WASI_SNAPSHOT), p2)
+TARGET_TRIPLE = wasm32-wasip2
+endif
+
+BUILTINS_LIB ?= $(shell ${CC} --print-libgcc-file-name)
+
 # These variables describe the locations of various files and directories in
 # the source tree.
-DLMALLOC_DIR = $(CURDIR)/dlmalloc
+DLMALLOC_DIR = dlmalloc
 DLMALLOC_SRC_DIR = $(DLMALLOC_DIR)/src
 DLMALLOC_SOURCES = $(DLMALLOC_SRC_DIR)/dlmalloc.c
 DLMALLOC_INC = $(DLMALLOC_DIR)/include
-EMMALLOC_DIR = $(CURDIR)/emmalloc
+EMMALLOC_DIR = emmalloc
 EMMALLOC_SOURCES = $(EMMALLOC_DIR)/emmalloc.c
-LIBC_BOTTOM_HALF_DIR = $(CURDIR)/libc-bottom-half
+LIBC_BOTTOM_HALF_DIR = libc-bottom-half
 LIBC_BOTTOM_HALF_CLOUDLIBC_SRC = $(LIBC_BOTTOM_HALF_DIR)/cloudlibc/src
 LIBC_BOTTOM_HALF_CLOUDLIBC_SRC_INC = $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/include
 LIBC_BOTTOM_HALF_HEADERS_PUBLIC = $(LIBC_BOTTOM_HALF_DIR)/headers/public
@@ -59,6 +76,43 @@
     $(sort \
     $(shell find $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC) -name \*.c) \
     $(shell find $(LIBC_BOTTOM_HALF_SOURCES) -name \*.c))
+
+ifeq ($(WASI_SNAPSHOT), p1)
+# Omit source files not relevant to WASIp1.  As we introduce files
+# supporting `wasi-sockets` for `wasm32-wasip2`, we'll add those files to
+# this list.
+LIBC_BOTTOM_HALF_OMIT_SOURCES := \
+	$(LIBC_BOTTOM_HALF_SOURCES)/wasip2.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/descriptor_table.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/connect.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/socket.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/send.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/recv.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/sockets_utils.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/bind.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/listen.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/accept-wasip2.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/shutdown.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/sockopt.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/poll-wasip2.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/getsockpeername.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/netdb.c
+LIBC_BOTTOM_HALF_ALL_SOURCES := $(filter-out $(LIBC_BOTTOM_HALF_OMIT_SOURCES),$(LIBC_BOTTOM_HALF_ALL_SOURCES))
+# Omit p2-specific headers from include-all.c test.
+# for exception-handling.
+INCLUDE_ALL_CLAUSES := -not -name wasip2.h -not -name descriptor_table.h
+endif
+
+ifeq ($(WASI_SNAPSHOT), p2)
+# Omit source files not relevant to WASIp2.
+LIBC_BOTTOM_HALF_OMIT_SOURCES := \
+	$(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/libc/sys/socket/send.c \
+	$(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/libc/sys/socket/recv.c \
+	$(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/libc/sys/socket/shutdown.c \
+	$(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/libc/sys/socket/getsockopt.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/accept-wasip1.c
+LIBC_BOTTOM_HALF_ALL_SOURCES := $(filter-out $(LIBC_BOTTOM_HALF_OMIT_SOURCES),$(LIBC_BOTTOM_HALF_ALL_SOURCES))
+endif
 
 # FIXME(https://reviews.llvm.org/D85567) - due to a bug in LLD the weak
 # references to a function defined in `chdir.c` only work if `chdir.c` is at the
@@ -78,8 +132,10 @@
 LIBWASI_EMULATED_SIGNAL_MUSL_SOURCES = \
     $(LIBC_TOP_HALF_MUSL_SRC_DIR)/signal/psignal.c \
     $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/strsignal.c
+LIBDL_SOURCES = $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/dl.c
+LIBSETJMP_SOURCES = $(LIBC_TOP_HALF_MUSL_SRC_DIR)/setjmp/wasm32/rt.c
 LIBC_BOTTOM_HALF_CRT_SOURCES = $(wildcard $(LIBC_BOTTOM_HALF_DIR)/crt/*.c)
-LIBC_TOP_HALF_DIR = $(CURDIR)/libc-top-half
+LIBC_TOP_HALF_DIR = libc-top-half
 LIBC_TOP_HALF_MUSL_DIR = $(LIBC_TOP_HALF_DIR)/musl
 LIBC_TOP_HALF_MUSL_SRC_DIR = $(LIBC_TOP_HALF_MUSL_DIR)/src
 LIBC_TOP_HALF_MUSL_INC = $(LIBC_TOP_HALF_MUSL_DIR)/include
@@ -97,6 +153,7 @@
         misc/getopt.c \
         misc/getopt_long.c \
         misc/getsubopt.c \
+        misc/realpath.c \
         misc/uname.c \
         misc/nftw.c \
         errno/strerror.c \
@@ -194,6 +251,13 @@
                  $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/complex/*.c)) \
     $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/crypt/*.c)
 
+ifeq ($(WASI_SNAPSHOT), p2)
+LIBC_TOP_HALF_MUSL_SOURCES += \
+    $(addprefix $(LIBC_TOP_HALF_MUSL_SRC_DIR)/, \
+       network/gai_strerror.c \
+    )
+endif
+
 ifeq ($(THREAD_MODEL), posix)
 LIBC_TOP_HALF_MUSL_SOURCES += \
     $(addprefix $(LIBC_TOP_HALF_MUSL_SRC_DIR)/, \
@@ -229,79 +293,10 @@
         thread/pthread_create.c \
         thread/pthread_detach.c \
         thread/pthread_equal.c \
+        thread/pthread_getattr_np.c \
         thread/pthread_getspecific.c \
         thread/pthread_join.c \
         thread/pthread_key_create.c \
         thread/pthread_mutex_consistent.c \
         thread/pthread_mutex_destroy.c \
         thread/pthread_mutex_init.c \
-        thread/pthread_mutex_getprioceiling.c \
-        thread/pthread_mutex_lock.c \
-        thread/pthread_mutex_timedlock.c \
-        thread/pthread_mutex_trylock.c \
-        thread/pthread_mutex_unlock.c \
-        thread/pthread_mutexattr_destroy.c \
-        thread/pthread_mutexattr_init.c \
-        thread/pthread_mutexattr_setprotocol.c \
-        thread/pthread_mutexattr_setpshared.c \
-        thread/pthread_mutexattr_setrobust.c \
-        thread/pthread_mutexattr_settype.c \
-        thread/pthread_once.c \
-        thread/pthread_rwlock_destroy.c \
-        thread/pthread_rwlock_init.c \
-        thread/pthread_rwlock_rdlock.c \
-        thread/pthread_rwlock_timedrdlock.c \
-        thread/pthread_rwlock_timedwrlock.c \
-        thread/pthread_rwlock_tryrdlock.c \
-        thread/pthread_rwlock_trywrlock.c \
-        thread/pthread_rwlock_unlock.c \
-        thread/pthread_rwlock_wrlock.c \
-        thread/pthread_rwlockattr_destroy.c \
-        thread/pthread_rwlockattr_init.c \
-        thread/pthread_rwlockattr_setpshared.c \
-        thread/pthread_setcancelstate.c \
-        thread/pthread_setspecific.c \
-        thread/pthread_self.c \
-        thread/pthread_testcancel.c \
-        thread/sem_destroy.c \
-        thread/sem_getvalue.c \
-        thread/sem_init.c \
-        thread/sem_post.c \
-        thread/sem_timedwait.c \
-        thread/sem_trywait.c \
-        thread/sem_wait.c \
-        thread/wasm32/wasi_thread_start.s \
-    )
-endif
-
-MUSL_PRINTSCAN_SOURCES = \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/floatscan.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfprintf.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfwprintf.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfscanf.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/strtod.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/wcstod.c
-BULK_MEMORY_SOURCES = \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/memcpy.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/memmove.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/memset.c
-LIBC_TOP_HALF_HEADERS_PRIVATE = $(LIBC_TOP_HALF_DIR)/headers/private
-LIBC_TOP_HALF_SOURCES = $(LIBC_TOP_HALF_DIR)/sources
-LIBC_TOP_HALF_ALL_SOURCES = \
-    $(LIBC_TOP_HALF_MUSL_SOURCES) \
-    $(sort $(shell find $(LIBC_TOP_HALF_SOURCES) -name \*.[cs]))
-
-# Add any extra flags
-CFLAGS = $(EXTRA_CFLAGS)
-# Set the target.
-CFLAGS += --target=$(TARGET_TRIPLE)
-ASMFLAGS += --target=$(TARGET_TRIPLE)
-# WebAssembly floating-point match doesn't trap.
-# TODO: Add -fno-signaling-nans when the compiler supports it.
-CFLAGS += -fno-trapping-math
-# Add all warnings, but disable a few which occur in third-party code.
-CFLAGS += -Wall -Wextra -Werror \
-  -Wno-null-pointer-arithmetic \
-  -Wno-unused-parameter \
-  -Wno-sign-compare \
-  -Wno-unused-variable \

=== debian/changelog ===
wasi-libc (0.0~git20240708.3f43ea9-2) unstable; urgency=medium

  * upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Fri, 25 Oct 2024 22:50:31 +0200

wasi-libc (0.0~git20240708.3f43ea9-1) experimental; urgency=medium

  * new upstream version needed for rustc 1.82+
  * switch to LLVM 19

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Tue, 22 Oct 2024 12:42:09 +0200

wasi-libc (0.0~git20240411.9e8c542-4) unstable; urgency=medium

  * switch to LLVM 18

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Mon, 09 Sep 2024 14:14:58 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Ximin Luo <infinity0@debian.org>,
  Fabian Grünbichler <debian@fabian.gruenbichler.email>
-Build-Depends: debhelper-compat (= 13), clang-17, llvm-17
+Build-Depends: debhelper-compat (= 13), clang-19, llvm-19
 Standards-Version: 4.6.2
 Homepage: https://github.com/CraneStation/wasi-libc
 Vcs-Browser: https://salsa.debian.org/rust-team/wasi-libc

=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,9 @@
 
 include /usr/share/dpkg/buildflags.mk
 
-export NM = llvm-nm-17
-export AR = llvm-ar-17
-export CC = clang-17
+export NM = llvm-nm-19
+export AR = llvm-ar-19
+export CC = clang-19
 
 # stack protector not yet supported, see
 # https://github.com/CraneStation/wasi-libc/issues/157
